stages:
  - deploy
  #- deploy
# This file is a template, and might need editing before it works on your project.
docker-build-master:
  # Official docker image.
  image: docker:latest
  variables:
    # When using dind service we need to instruct docker, to talk with
    # the daemon started inside of the service. The daemon is
    # available with a network connection instead of the default
    # /var/run/docker.sock socket. docker:19.03-dind does this
    # automatically by setting the DOCKER_HOST in
    # https://github.com/docker-library/docker/blob/d45051476babc297257df490d22cbd806f1b11e4/19.03/docker-entrypoint.sh#L23-L29
    #
    # The 'docker' hostname is the alias of the service container as described at
    # https://docs.gitlab.com/ee/ci/docker/using_docker_images.html#accessing-the-services.
    #
    # Note that if you're using the Kubernetes executor, the variable should be set to
    # tcp://localhost:2376/ because of how the Kubernetes executor connects services
    # to the job container
    # DOCKER_HOST: tcp://localhost:2376/
    #
    # When using dind, it's wise to use the overlayfs driver for
    # improved performance.
    DOCKER_DRIVER: overlay2
    # Specify to Docker where to create the certificates, Docker will
    # create them automatically on boot, and will create
    # `/certs/client` that will be shared between the service and
    # build container.
    DOCKER_TLS_CERTDIR: "/certs"
    POSTGRESQL_HOST_PATH: "/opt/postgresql-ecoticket"
    DOCKER_CONTAINER_NAME: "postgresql-ecoticket_postgresql"
  stage: deploy
  services: 
    - docker:dind
  before_script:
    # Install ssh-agent if not already installed, it is required by Docker.
    # (change apt-get to yum if you use a CentOS-based image)
    - 'which ssh-agent || ( apk update -y && apk install openssh-client -y )'
    # Run ssh-agent (inside the build environment)
    - eval `ssh-agent -s`
    # Add the SSH key stored in SSH_PRIVATE_KEY variable to the agent store
    #- ssh-add <(echo "$SSH_PRIVATE_KEY")
    #- echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - echo "$SSH_PRIVATE_KEY" > /tmp/gitlab_ci_ssh
    - chmod 600 /tmp/gitlab_ci_ssh
    - ssh-add /tmp/gitlab_ci_ssh
    ##
    ## Create the SSH directory and give it the right permissions
    ##
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    ##
    ## Use ssh-keyscan to scan the keys of your private server. Replace gitlab.com
    ## with your own domain name. You can copy and repeat that command if you have
    ## more than one server to connect to.
    ##
    - ssh-keyscan ${DEPLOYMENT_SERVER_IP} >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
    ##
    ## You can optionally disable host key checking. Be aware that by adding that
    ## you are suspectible to man-in-the-middle attacks.
    ## WARNING: Use this only with the Docker executor, if you use it with shell
    ## you will overwrite your user's SSH config.
    ##
    #- '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    ##
    ## Optionally, if you will be using any Git commands, set the user name and
    ## email.
    ##
    #- docker info
    #- apk update
    #- apk upgrade
    #- apk add python python-dev libffi-dev openssl-dev python3-dev py-pip build-base
    #- pip install docker-compose
    #- mv env .env
  script:
    #- docker-compose build --pull -t "$CI_REGISTRY_IMAGE" .
    #- docker-compose push "$CI_REGISTRY_IMAGE"
    #- docker-compose --version
    - echo ${POSTGRESQL_PASSWORD}
    - echo ${POSTGRESQL_USERNAME}
    - ssh ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP} "if [ -d $POSTGRESQL_HOST_PATH ]; then rm -Rf $POSTGRESQL_HOST_PATH; fi"
    - ssh ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP} "mkdir $POSTGRESQL_HOST_PATH && cd $POSTGRESQL_HOST_PATH && echo 'POSTGRESQL_PASSWORD=$POSTGRESQL_PASSWORD' > .env && echo 'POSTGRESQL_USERNAME=$POSTGRESQL_USERNAME' >> .env && echo 'POSTGRESQL_DATABASE=$POSTGRESQL_DATABASE' >> .env"
    #- scp ./.env ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP}:$POSTGRESQL_HOST_PATH
    - scp ./ecotickets.sql ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP}:$POSTGRESQL_HOST_PATH
    - scp ./docker-compose.yml ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP}:$POSTGRESQL_HOST_PATH
    - ssh ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP} "docker container stop $DOCKER_CONTAINER_NAME && docker container rm $DOCKER_CONTAINER_NAME || true"
    # - ssh ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP} "docker volume rm $(docker volume ls -qf name=postgresql_data)"
    - ssh ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP} "cd $POSTGRESQL_HOST_PATH && docker-compose up -d"
  only:
    - master
  tags:
    - postgresql-testing
